#include "projet.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

extern GtkWidget *gl_window;

GtkWidget *
create_filters_window (void)
{
  GtkWidget *filters_window;
  GtkWidget *fw_vbox1;
  GtkWidget *hbox1;
  GtkWidget *fw_image1;
  GtkWidget *fw_infolbl;
  GtkWidget *hseparator1;
  GtkWidget *fw_table1;
  GtkWidget *fw_label2;
  GtkWidget *fw_label1;
  GtkWidget *fw_option1;
  GtkWidget *menu1;
  GtkWidget *menu2;
  GtkWidget *menu3;
  GtkWidget *menu4;
  GtkWidget *fwm_fir;
  GtkWidget *fwm_puissance;
  GtkWidget *fwm_riviere;
  GtkWidget *fwm_crateres;
  GtkWidget *fwm_aucun;
  GtkWidget *fw_option2;
  GtkWidget *fw_option3;
  GtkWidget *fw_option4;
  GtkWidget *fw_pos1lbl;
  GtkWidget *fw_pos3lbl;
  GtkWidget *fw_pos4lbl;
  GtkWidget *fw_poslbl;
  GtkWidget *fw_hscale2;
  GtkWidget *fw_hscale3;
  GtkWidget *fw_hscale4;
  GtkWidget *fw_val1;
  GtkWidget *fw_val2;
  GtkWidget *fw_val3;
  GtkWidget *fw_val4;
  GtkWidget *fw_empty;
  GtkWidget *fw_pos2lbl;
  GtkWidget *fw_hscale1;
  GtkWidget *fw_sep1;
  GtkWidget *fw_hbuttonbox1;
  GtkWidget *fw_quitb;
  GtkWidget *fw_okb;
  GtkWidget *alignment3;
  GtkWidget *hbox3;
  GtkWidget *image57;
  GtkWidget *label3;
  
  GtkWidget *fw_colorhb;
  GtkWidget *fw_colorlbl;
  GtkWidget *fw_sep2;
  GtkWidget *fw_colors1;
  GtkWidget *colorsmenu;
  GtkWidget *fwm_summer;
  GtkWidget *fwm_mars;
  GtkWidget *fwm_venus;
  
  GtkTooltips *fw_tips1, *fw_tips2, *fw_tips3, *fw_tips4;

  filters_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (filters_window), 8);
  gtk_window_set_title (GTK_WINDOW (filters_window), _("Fenetre de filtres"));
  gtk_window_set_resizable (GTK_WINDOW (filters_window), FALSE);
  gtk_window_set_transient_for (GTK_WINDOW (filters_window),
				GTK_WINDOW (gl_window));

  fw_vbox1 = gtk_vbox_new (FALSE, 13);
  gtk_widget_show (fw_vbox1);
  gtk_container_add (GTK_CONTAINER (filters_window), fw_vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (fw_vbox1), 1);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (fw_vbox1), hbox1, TRUE, TRUE, 0);

  fw_image1 = gtk_image_new_from_stock ("gtk-dialog-info", GTK_ICON_SIZE_DND);
  gtk_widget_show (fw_image1);
  gtk_box_pack_start (GTK_BOX (hbox1), fw_image1, TRUE, TRUE, 0);

  fw_infolbl =
    gtk_label_new (_
		   ("Choisissez les filtres a appliquer, puis ajustez \nle parametre correspondant.\nAttention, l'ordre d'application compte !"));
  gtk_widget_show (fw_infolbl);
  gtk_box_pack_start (GTK_BOX (hbox1), fw_infolbl, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (fw_infolbl), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (fw_infolbl), TRUE);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (fw_vbox1), hseparator1, TRUE, TRUE, 0);

  fw_table1 = gtk_table_new (5, 4, FALSE);
  gtk_widget_show (fw_table1);
  gtk_box_pack_start (GTK_BOX (fw_vbox1), fw_table1, FALSE, TRUE, 0);
  gtk_table_set_row_spacings (GTK_TABLE (fw_table1), 9);
  gtk_table_set_col_spacings (GTK_TABLE (fw_table1), 11);

  fw_label2 = gtk_label_new (_("Parametres"));
  gtk_widget_show (fw_label2);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_label2, 2, 3, 0, 1,
		    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (fw_label2), 0, 0.5);

  fw_label1 = gtk_label_new (_("Filtres"));
  gtk_widget_show (fw_label1);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_label1, 1, 2, 0, 1,
		    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (fw_label1), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (fw_label1), 0, 0.5);

  fw_option1 = gtk_option_menu_new ();
  gtk_widget_show (fw_option1);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_option1, 1, 2, 1, 2,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);

  menu1 = gtk_menu_new ();

  fwm_aucun = gtk_menu_item_new_with_mnemonic (_("Aucun"));
  gtk_widget_show (fwm_aucun);
  gtk_container_add (GTK_CONTAINER (menu1), fwm_aucun);

  fwm_fir = gtk_menu_item_new_with_mnemonic (_("FIR (lissage)"));
  gtk_widget_show (fwm_fir);
  gtk_container_add (GTK_CONTAINER (menu1), fwm_fir);

  fwm_puissance = gtk_menu_item_new_with_mnemonic (_("Puissance"));
  gtk_widget_show (fwm_puissance);
  gtk_container_add (GTK_CONTAINER (menu1), fwm_puissance);

  fwm_riviere = gtk_menu_item_new_with_mnemonic (_("Riviere"));
  gtk_widget_show (fwm_riviere);
  gtk_container_add (GTK_CONTAINER (menu1), fwm_riviere);

  fwm_crateres = gtk_menu_item_new_with_mnemonic (_("Crateres"));
  gtk_widget_show (fwm_crateres);
  gtk_container_add (GTK_CONTAINER (menu1), fwm_crateres);


  gtk_option_menu_set_menu (GTK_OPTION_MENU (fw_option1), menu1);

  menu2 = gtk_menu_new ();

  fwm_aucun = gtk_menu_item_new_with_mnemonic (_("Aucun"));
  gtk_widget_show (fwm_aucun);
  gtk_container_add (GTK_CONTAINER (menu2), fwm_aucun);

  fwm_fir = gtk_menu_item_new_with_mnemonic (_("FIR (lissage)"));
  gtk_widget_show (fwm_fir);
  gtk_container_add (GTK_CONTAINER (menu2), fwm_fir);

  fwm_puissance = gtk_menu_item_new_with_mnemonic (_("Puissance"));
  gtk_widget_show (fwm_puissance);
  gtk_container_add (GTK_CONTAINER (menu2), fwm_puissance);

  fwm_riviere = gtk_menu_item_new_with_mnemonic (_("Riviere"));
  gtk_widget_show (fwm_riviere);
  gtk_container_add (GTK_CONTAINER (menu2), fwm_riviere);

  fwm_crateres = gtk_menu_item_new_with_mnemonic (_("Crateres"));
  gtk_widget_show (fwm_crateres);
  gtk_container_add (GTK_CONTAINER (menu2), fwm_crateres);




  menu3 = gtk_menu_new ();

  fwm_aucun = gtk_menu_item_new_with_mnemonic (_("Aucun"));
  gtk_widget_show (fwm_aucun);
  gtk_container_add (GTK_CONTAINER (menu3), fwm_aucun);

  fwm_fir = gtk_menu_item_new_with_mnemonic (_("FIR (lissage)"));
  gtk_widget_show (fwm_fir);
  gtk_container_add (GTK_CONTAINER (menu3), fwm_fir);

  fwm_puissance = gtk_menu_item_new_with_mnemonic (_("Puissance"));
  gtk_widget_show (fwm_puissance);
  gtk_container_add (GTK_CONTAINER (menu3), fwm_puissance);

  fwm_riviere = gtk_menu_item_new_with_mnemonic (_("Riviere"));
  gtk_widget_show (fwm_riviere);
  gtk_container_add (GTK_CONTAINER (menu3), fwm_riviere);

  fwm_crateres = gtk_menu_item_new_with_mnemonic (_("Crateres"));
  gtk_widget_show (fwm_crateres);
  gtk_container_add (GTK_CONTAINER (menu3), fwm_crateres);

  menu4 = gtk_menu_new ();

  fwm_aucun = gtk_menu_item_new_with_mnemonic (_("Aucun"));
  gtk_widget_show (fwm_aucun);
  gtk_container_add (GTK_CONTAINER (menu4), fwm_aucun);

  fwm_fir = gtk_menu_item_new_with_mnemonic (_("FIR (lissage)"));
  gtk_widget_show (fwm_fir);
  gtk_container_add (GTK_CONTAINER (menu4), fwm_fir);

  fwm_puissance = gtk_menu_item_new_with_mnemonic (_("Puissance"));
  gtk_widget_show (fwm_puissance);
  gtk_container_add (GTK_CONTAINER (menu4), fwm_puissance);

  fwm_riviere = gtk_menu_item_new_with_mnemonic (_("Riviere"));
  gtk_widget_show (fwm_riviere);
  gtk_container_add (GTK_CONTAINER (menu4), fwm_riviere);

  fwm_crateres = gtk_menu_item_new_with_mnemonic (_("Crateres"));
  gtk_widget_show (fwm_crateres);
  gtk_container_add (GTK_CONTAINER (menu4), fwm_crateres);


  fw_option2 = gtk_option_menu_new ();
  gtk_widget_show (fw_option2);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_option2, 1, 2, 2, 3,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);

  gtk_option_menu_set_menu (GTK_OPTION_MENU (fw_option2), menu2);

  fw_option3 = gtk_option_menu_new ();
  gtk_widget_show (fw_option3);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_option3, 1, 2, 3, 4,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);

  gtk_option_menu_set_menu (GTK_OPTION_MENU (fw_option3), menu3);

  fw_option4 = gtk_option_menu_new ();
  gtk_widget_show (fw_option4);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_option4, 1, 2, 4, 5,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);

  gtk_option_menu_set_menu (GTK_OPTION_MENU (fw_option4), menu4);


  gtk_option_menu_set_history (GTK_OPTION_MENU (fw_option1),
			       TERR_FILTER_NOTHING);
  gtk_option_menu_set_history (GTK_OPTION_MENU (fw_option2),
			       TERR_FILTER_NOTHING);
  gtk_option_menu_set_history (GTK_OPTION_MENU (fw_option3),
			       TERR_FILTER_NOTHING);
  gtk_option_menu_set_history (GTK_OPTION_MENU (fw_option4),
			       TERR_FILTER_NOTHING);

  fw_pos1lbl = gtk_label_new (_("1"));
  gtk_widget_show (fw_pos1lbl);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_pos1lbl, 0, 1, 1, 2,
		    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (fw_pos1lbl), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (fw_pos1lbl), 0, 0.5);

  fw_pos3lbl = gtk_label_new (_("3"));
  gtk_widget_show (fw_pos3lbl);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_pos3lbl, 0, 1, 3, 4,
		    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (fw_pos3lbl), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (fw_pos3lbl), 0, 0.5);

  fw_pos4lbl = gtk_label_new (_("4"));
  gtk_widget_show (fw_pos4lbl);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_pos4lbl, 0, 1, 4, 5,
		    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (fw_pos4lbl), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (fw_pos4lbl), 0, 0.5);

  fw_poslbl = gtk_label_new (_("Pos."));
  gtk_widget_show (fw_poslbl);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_poslbl, 0, 1, 0, 1,
		    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (fw_poslbl), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (fw_poslbl), 0, 0.5);

  fw_hscale2 =
    gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 100, 0, 0, 0)));
  gtk_widget_show (fw_hscale2);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_hscale2, 2, 3, 2, 3,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_widget_set_size_request (fw_hscale2, 165, -1);
  gtk_scale_set_draw_value (GTK_SCALE (fw_hscale2), FALSE);

  fw_hscale3 =
    gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 100, 0, 0, 0)));
  gtk_widget_show (fw_hscale3);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_hscale3, 2, 3, 3, 4,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_widget_set_size_request (fw_hscale3, 165, -1);
  gtk_scale_set_draw_value (GTK_SCALE (fw_hscale3), FALSE);

  fw_hscale4 =
    gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 100, 0, 0, 0)));
  gtk_widget_show (fw_hscale4);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_hscale4, 2, 3, 4, 5,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_widget_set_size_request (fw_hscale4, 165, -1);
  gtk_scale_set_draw_value (GTK_SCALE (fw_hscale4), FALSE);

  fw_val1 = gtk_label_new (_("0,00"));
  gtk_widget_show (fw_val1);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_val1, 3, 4, 1, 2,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (fw_val1), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (fw_val1), 0, 0.5);

  fw_val2 = gtk_label_new (_("0,00"));
  gtk_widget_show (fw_val2);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_val2, 3, 4, 2, 3,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (fw_val2), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (fw_val2), 0, 0.5);

  fw_val3 = gtk_label_new (_("0,00"));
  gtk_widget_show (fw_val3);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_val3, 3, 4, 3, 4,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (fw_val3), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (fw_val3), 0, 0.5);

  fw_val4 = gtk_label_new (_("0,00"));
  gtk_widget_show (fw_val4);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_val4, 3, 4, 4, 5,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (fw_val4), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (fw_val4), 0, 0.5);

  fw_empty = gtk_label_new ("");
  gtk_widget_show (fw_empty);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_empty, 3, 4, 0, 1,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (fw_empty), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (fw_empty), 0, 0.5);

  fw_pos2lbl = gtk_label_new (_("2"));
  gtk_widget_show (fw_pos2lbl);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_pos2lbl, 0, 1, 2, 3,
		    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (fw_pos2lbl), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (fw_pos2lbl), 0, 0.5);

  fw_hscale1 =
    gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 100, 0, 0, 0)));
  gtk_widget_show (fw_hscale1);
  gtk_table_attach (GTK_TABLE (fw_table1), fw_hscale1, 2, 3, 1, 2,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_widget_set_size_request (fw_hscale1, 165, -1);
  gtk_scale_set_draw_value (GTK_SCALE (fw_hscale1), FALSE);

  fw_sep1 = gtk_hseparator_new ();
  gtk_widget_show (fw_sep1);
  gtk_box_pack_start (GTK_BOX (fw_vbox1), fw_sep1, TRUE, TRUE, 0);
/************************/
  fw_colorhb = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (fw_colorhb);
  gtk_box_pack_start (GTK_BOX (fw_vbox1), fw_colorhb, TRUE, TRUE, 0);

  fw_colorlbl =
    gtk_label_new (_
		   ("Schema de couleurs  "));
  gtk_widget_show (fw_colorlbl);
  gtk_box_pack_start (GTK_BOX (fw_colorhb), fw_colorlbl, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (fw_colorlbl), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (fw_colorlbl), TRUE);
  
  fw_colors1 = gtk_option_menu_new ();
  gtk_widget_show (fw_colors1);
  gtk_box_pack_start (GTK_BOX (fw_colorhb), fw_colors1, FALSE, FALSE, 0);

  colorsmenu = gtk_menu_new ();

  fwm_summer = gtk_menu_item_new_with_mnemonic (_("Ete (bleu - vert - blanc)"));
  gtk_widget_show (fwm_summer);
  gtk_container_add (GTK_CONTAINER (colorsmenu), fwm_summer);

  fwm_mars = gtk_menu_item_new_with_mnemonic (_("Mars (rouge - orange)"));
  gtk_widget_show (fwm_mars);
  gtk_container_add (GTK_CONTAINER (colorsmenu), fwm_mars);

  fwm_venus = gtk_menu_item_new_with_mnemonic (_("Venus (bleu - orange - violet)"));
  gtk_widget_show (fwm_venus);
  gtk_container_add (GTK_CONTAINER (colorsmenu), fwm_venus);

  gtk_option_menu_set_menu (GTK_OPTION_MENU (fw_colors1), colorsmenu);
/************************/
  fw_sep2 = gtk_hseparator_new ();
  gtk_widget_show (fw_sep2);
  gtk_box_pack_start (GTK_BOX (fw_vbox1), fw_sep2, TRUE, TRUE, 0);

  fw_hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (fw_hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (fw_vbox1), fw_hbuttonbox1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (fw_hbuttonbox1), 2);

  /*fw_quitb = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (fw_quitb);
  gtk_container_add (GTK_CONTAINER (fw_hbuttonbox1), fw_quitb);
  GTK_WIDGET_SET_FLAGS (fw_quitb, GTK_CAN_DEFAULT);*/
  
  fw_quitb = gtk_button_new();
  gtk_widget_show (fw_quitb);
  gtk_container_add (GTK_CONTAINER (fw_hbuttonbox1), fw_quitb);
  
  alignment3 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment3);
  gtk_container_add (GTK_CONTAINER (fw_quitb), alignment3);

  hbox3 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox3);
  gtk_container_add (GTK_CONTAINER (alignment3), hbox3);

  image57 = gtk_image_new_from_stock ("gtk-cancel", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image57);
  gtk_box_pack_start (GTK_BOX (hbox3), image57, FALSE, FALSE, 0);

  label3 = gtk_label_new_with_mnemonic (_("Fermer"));

  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (hbox3), label3, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);

  fw_okb = gtk_button_new_from_stock ("gtk-refresh");
  gtk_widget_show (fw_okb);
  gtk_container_add (GTK_CONTAINER (fw_hbuttonbox1), fw_okb);
  GTK_WIDGET_SET_FLAGS (fw_okb, GTK_CAN_DEFAULT);

  gtk_widget_set_sensitive (fw_hscale1, FALSE);
  gtk_widget_set_sensitive (fw_hscale2, FALSE);
  gtk_widget_set_sensitive (fw_hscale3, FALSE);
  gtk_widget_set_sensitive (fw_hscale4, FALSE);
  
  fw_tips1 = gtk_tooltips_new ();
  fw_tips2 = gtk_tooltips_new ();
  fw_tips3 = gtk_tooltips_new ();
  fw_tips4 = gtk_tooltips_new ();
  
  g_signal_connect ((gpointer) filters_window, "destroy",
		    G_CALLBACK (on_filters_window_destroy), NULL);
        
  g_signal_connect ((gpointer) fw_option1, "changed",
     G_CALLBACK (on_menu1_changed), G_OBJECT (filters_window));
  g_signal_connect ((gpointer) fw_option2, "changed",
     G_CALLBACK (on_menu2_changed), G_OBJECT (filters_window));
  g_signal_connect ((gpointer) fw_option3, "changed",
     G_CALLBACK (on_menu3_changed), G_OBJECT (filters_window));
  g_signal_connect ((gpointer) fw_option4, "changed",
     G_CALLBACK (on_menu4_changed), G_OBJECT (filters_window));   
   
  g_signal_connect ((gpointer) fw_hscale2, "value_changed",
		    G_CALLBACK (on_fw_hscale2_value_changed), G_OBJECT (filters_window));
  g_signal_connect ((gpointer) fw_hscale3, "value_changed",
		    G_CALLBACK (on_fw_hscale3_value_changed), G_OBJECT (filters_window));
  g_signal_connect ((gpointer) fw_hscale4, "value_changed",
		    G_CALLBACK (on_fw_hscale4_value_changed), G_OBJECT (filters_window));
  g_signal_connect ((gpointer) fw_hscale1, "value_changed",
		    G_CALLBACK (on_fw_hscale1_value_changed), G_OBJECT (filters_window));
  g_signal_connect ((gpointer) fw_quitb, "clicked",
		    G_CALLBACK (on_fw_quitb_clicked),
		    G_OBJECT (filters_window));
  g_signal_connect ((gpointer) fw_okb, "clicked",
		    G_CALLBACK (on_fw_okb_clicked),
		    G_OBJECT (filters_window));

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (filters_window, filters_window,
			      "filters_window");
  GLADE_HOOKUP_OBJECT (filters_window, fw_vbox1, "fw_vbox1");
  GLADE_HOOKUP_OBJECT (filters_window, hbox1, "hbox1");
  GLADE_HOOKUP_OBJECT (filters_window, fw_image1, "fw_image1");
  GLADE_HOOKUP_OBJECT (filters_window, fw_infolbl, "fw_infolbl");
  GLADE_HOOKUP_OBJECT (filters_window, hseparator1, "hseparator1");
  GLADE_HOOKUP_OBJECT (filters_window, fw_table1, "fw_table1");
  GLADE_HOOKUP_OBJECT (filters_window, fw_label2, "fw_label2");
  GLADE_HOOKUP_OBJECT (filters_window, fw_label1, "fw_label1");
  GLADE_HOOKUP_OBJECT (filters_window, fw_option1, "fw_option1");
  GLADE_HOOKUP_OBJECT (filters_window, menu1, "menu1");
  GLADE_HOOKUP_OBJECT (filters_window, fwm_fir, "fwm_fir");
  GLADE_HOOKUP_OBJECT (filters_window, fwm_puissance, "fwm_puissance");
  GLADE_HOOKUP_OBJECT (filters_window, fwm_riviere, "fwm_riviere");
  GLADE_HOOKUP_OBJECT (filters_window, fwm_crateres, "fwm_crateres");
  GLADE_HOOKUP_OBJECT (filters_window, fwm_aucun, "fwm_aucun");
  GLADE_HOOKUP_OBJECT (filters_window, fw_option2, "fw_option2");
  GLADE_HOOKUP_OBJECT (filters_window, fw_option3, "fw_option3");
  GLADE_HOOKUP_OBJECT (filters_window, fw_option4, "fw_option4");
  GLADE_HOOKUP_OBJECT (filters_window, fw_pos1lbl, "fw_pos1lbl");
  GLADE_HOOKUP_OBJECT (filters_window, fw_pos3lbl, "fw_pos3lbl");
  GLADE_HOOKUP_OBJECT (filters_window, fw_pos4lbl, "fw_pos4lbl");
  GLADE_HOOKUP_OBJECT (filters_window, fw_poslbl, "fw_poslbl");
  GLADE_HOOKUP_OBJECT (filters_window, fw_hscale2, "fw_hscale2");
  GLADE_HOOKUP_OBJECT (filters_window, fw_hscale3, "fw_hscale3");
  GLADE_HOOKUP_OBJECT (filters_window, fw_hscale4, "fw_hscale4");
  GLADE_HOOKUP_OBJECT (filters_window, fw_val1, "fw_val1");
  GLADE_HOOKUP_OBJECT (filters_window, fw_val2, "fw_val2");
  GLADE_HOOKUP_OBJECT (filters_window, fw_val3, "fw_val3");
  GLADE_HOOKUP_OBJECT (filters_window, fw_val4, "fw_val4");
  GLADE_HOOKUP_OBJECT (filters_window, fw_empty, "fw_empty");
  GLADE_HOOKUP_OBJECT (filters_window, fw_pos2lbl, "fw_pos2lbl");
  GLADE_HOOKUP_OBJECT (filters_window, fw_hscale1, "fw_hscale1");
  GLADE_HOOKUP_OBJECT (filters_window, fw_sep1, "fw_sep1");
  GLADE_HOOKUP_OBJECT (filters_window, fw_hbuttonbox1, "fw_hbuttonbox1");
  GLADE_HOOKUP_OBJECT (filters_window, fw_quitb, "fw_quitb");
  GLADE_HOOKUP_OBJECT (filters_window, fw_okb, "fw_okb");
  GLADE_HOOKUP_OBJECT (filters_window, fw_colors1, "fw_colors1");
  
  g_object_set_data_full (G_OBJECT (filters_window), "fw_tips1",
    g_object_ref (G_OBJECT(fw_tips1)), (GDestroyNotify) g_object_unref);
    
  g_object_set_data_full (G_OBJECT (filters_window), "fw_tips2",
    g_object_ref (G_OBJECT(fw_tips2)), (GDestroyNotify) g_object_unref);
    
  g_object_set_data_full (G_OBJECT (filters_window), "fw_tips3",
    g_object_ref (G_OBJECT(fw_tips3)), (GDestroyNotify) g_object_unref);

  g_object_set_data_full (G_OBJECT (filters_window), "fw_tips4",
    g_object_ref (G_OBJECT(fw_tips4)), (GDestroyNotify) g_object_unref);
    
  /*GLADE_HOOKUP_OBJECT (filters_window, GTK_WIDGET(fw_tips1), "fw_tips1");
  GLADE_HOOKUP_OBJECT (filters_window, GTK_WIDGET(fw_tips2), "fw_tips2");
  GLADE_HOOKUP_OBJECT (filters_window, GTK_WIDGET(fw_tips3), "fw_tips3");
  GLADE_HOOKUP_OBJECT (filters_window, GTK_WIDGET(fw_tips4), "fw_tips4");*/

  return filters_window;
}
