#include "projet.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

extern GtkWidget *gl_window;

GtkWidget*
create_middisp_window (void)
{
  GtkWidget *middsp_window;
  GtkWidget *middspw_vbox1;
  GtkWidget *middspw_paramlbl;
  GtkWidget *middspw_hseparator1;
  GtkWidget *middspw_table1;
  GtkObject *middspw_hsb_adj;
  GtkWidget *middspw_hsb;
  GtkWidget *middspw_label2;
  GtkWidget *middspw_label6;
  GtkObject *middspw_factsb_adj;
  GtkWidget *middspw_factsb;
  GtkWidget *middspw_hseparator2;
  GtkWidget *middspw_hbuttonbox1;
  GtkWidget *middspw_okb;

  middsp_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (middsp_window), 3);
  gtk_window_set_transient_for(GTK_WINDOW (middsp_window),GTK_WINDOW (gl_window));
  gtk_window_set_title (GTK_WINDOW (middsp_window), _("Middpoint Disp."));

  middspw_vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (middspw_vbox1);
  gtk_container_add (GTK_CONTAINER (middsp_window), middspw_vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (middspw_vbox1), 2);

  middspw_paramlbl = gtk_label_new (_("Parametres"));
  gtk_widget_show (middspw_paramlbl);
  gtk_box_pack_start (GTK_BOX (middspw_vbox1), middspw_paramlbl, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (middspw_paramlbl), GTK_JUSTIFY_LEFT);

  middspw_hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (middspw_hseparator1);
  gtk_box_pack_start (GTK_BOX (middspw_vbox1), middspw_hseparator1, TRUE, TRUE, 0);

  middspw_table1 = gtk_table_new (5, 2, FALSE);
  gtk_widget_show (middspw_table1);
  gtk_box_pack_start (GTK_BOX (middspw_vbox1), middspw_table1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (middspw_table1), 10);
  gtk_table_set_row_spacings (GTK_TABLE (middspw_table1), 3);
  gtk_table_set_col_spacings (GTK_TABLE (middspw_table1), 12);

  middspw_label2 = gtk_label_new (_("Perturbation du terrain"));
  gtk_widget_show (middspw_label2);
  gtk_table_attach (GTK_TABLE (middspw_table1), middspw_label2, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (middspw_label2), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (middspw_label2), 0, 0.5);
  
  middspw_hsb_adj = gtk_adjustment_new (0.920, 0, 1, 0.001, 0.5, 0.5);
  middspw_hsb = gtk_spin_button_new (GTK_ADJUSTMENT (middspw_hsb_adj), 0.1, 3);
  gtk_widget_show (middspw_hsb);
  gtk_table_attach (GTK_TABLE (middspw_table1), middspw_hsb, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (middspw_hsb), TRUE);

  middspw_label6 = gtk_label_new (_("Facteur d'altitude"));
  gtk_widget_show (middspw_label6);
  gtk_table_attach (GTK_TABLE (middspw_table1), middspw_label6, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (middspw_label6), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (middspw_label6), 0, 0.5);

  middspw_factsb_adj = gtk_adjustment_new (200, 1, 600, 1, 10, 10);
  middspw_factsb = gtk_spin_button_new (GTK_ADJUSTMENT (middspw_factsb_adj), 1, 0);
  gtk_widget_show (middspw_factsb);
  gtk_table_attach (GTK_TABLE (middspw_table1), middspw_factsb, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  middspw_hseparator2 = gtk_hseparator_new ();
  gtk_widget_show (middspw_hseparator2);
  gtk_box_pack_start (GTK_BOX (middspw_vbox1), middspw_hseparator2, TRUE, TRUE, 0);

  middspw_hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (middspw_hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (middspw_vbox1), middspw_hbuttonbox1, TRUE, TRUE, 0);

  middspw_okb = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (middspw_okb);
  gtk_container_add (GTK_CONTAINER (middspw_hbuttonbox1), middspw_okb);
  GTK_WIDGET_SET_FLAGS (middspw_okb, GTK_CAN_DEFAULT);

          
  g_signal_connect ((gpointer) middspw_okb, "clicked",
                    G_CALLBACK (on_middispw_okb_clicked),
                    G_OBJECT (middsp_window));
                    
  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (middsp_window, middsp_window, "middsp_window");
  GLADE_HOOKUP_OBJECT (middsp_window, middspw_vbox1, "middspw_vbox1");
  GLADE_HOOKUP_OBJECT (middsp_window, middspw_paramlbl, "middspw_paramlbl");
  GLADE_HOOKUP_OBJECT (middsp_window, middspw_hseparator1, "middspw_hseparator1");
  GLADE_HOOKUP_OBJECT (middsp_window, middspw_table1, "middspw_table1");
  GLADE_HOOKUP_OBJECT (middsp_window, middspw_hsb, "middspw_hsb");
  GLADE_HOOKUP_OBJECT (middsp_window, middspw_label2, "middspw_label2");
  GLADE_HOOKUP_OBJECT (middsp_window, middspw_label6, "middspw_label6");
  GLADE_HOOKUP_OBJECT (middsp_window, middspw_factsb, "middspw_factsb");
  GLADE_HOOKUP_OBJECT (middsp_window, middspw_hseparator2, "middspw_hseparator2");
  GLADE_HOOKUP_OBJECT (middsp_window, middspw_hbuttonbox1, "middspw_hbuttonbox1");
  GLADE_HOOKUP_OBJECT (middsp_window, middspw_okb, "middspw_okb");

  gtk_widget_grab_focus (middspw_okb);
  gtk_widget_grab_default (middspw_okb);
  return middsp_window;
}
