/* Fichier; main.c
 * contient la fonction main du programme
 */

#include "projet.h"

#ifndef USE_GLUT
/*GtkWidget *param_window;*/
GtkWidget *gl_window;
#endif

terrain_t *terrain;

/* ======================================================
 * main
 * =====================================================
 */
int main (int argc, char *argv[])
{

#ifndef USE_GLUT

 #ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
 #endif /* ENABLE_NLS */

  gtk_set_locale ();
  gtk_init (&argc, &argv);
  gtk_gl_init (&argc, &argv);
  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");
#endif /* not defined USE_GLUT */
  
  if (create_new_terrain(&terrain) == 0) {
    fprintf(stderr,"not enough memory to create terrain\n");
    exit(1);
  }
    
  cam_init();

#ifndef USE_GLUT
  /*param_window = create_paraw_window ();
     gtk_widget_show (param_window); */
   
  gl_window = create_gl_window ();
  gtk_widget_show(gl_window);
 
    
  gtk_main ();
#else
  glutInit(&argc, argv);
  set_up_glut ();  
  glutMainLoop();
  
#endif /* not defined USE_GLUT */

  return 0;
}

