#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

#include "terrain.h"
#include "common.h"

#define NUM_ITER 50

void gen_terrain_sphere(terrain_t *terrain)
{
  int x1,y1,x2,y2;
  float z=0;
  float radius = 1.0f;
  int iter=0;
  
  srand( time(NULL) );
   
  for (iter=0; iter < NUM_ITER ; iter++) {

    x1 = random_int(terrain->size - 1);
    y1 = random_int(terrain->size - 1);
    radius = random_float(3.0f,20.0f);
  
    for (x2 =0; x2 < terrain->size; x2++) {
      for (y2 =0; y2 < terrain->size; y2++) {
        z = radius*radius - ( (x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) );
      
        if (z < 0) 
          z=0;
        else 
          z=sqrt(z);
      
        z += get_heightmap_value(terrain,x2,y2);
	
        if (z > terrain->max_height) 
	   terrain->max_height = z;
	   
        set_heightmap_value(terrain,x2,y2,z);
      }
    }
  }
  
  printf("SPHERE: max_height=%f\n",terrain->max_height);  
}


/* cree une sphere au milieu du terrain */
/* n'est utile que pour des tests simples */
void gen_terrain_one_sphere(terrain_t *terrain)
{
  int x1,y1,x2,y2;
  float z=0;
  float radius = (float)(terrain->size) / 4.0f;
   
  /* on prend le milieu du terrain */
  x1 = (int)terrain->size/2;
  y1 = (int)terrain->size/2;
  
  printf("SPHERE: terrain: %d, centre=(%d,%d), radius=%f\n",
     terrain->size,x1,y1,radius);
  
  for (x2 =0; x2 < terrain->size; x2++) {
    for (y2 =0; y2 < terrain->size; y2++) {
      z = radius*radius - ( (x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) );
      
      if (z < 0) 
        z=0;
      else 
        z=sqrt(z);
      
      if (z > terrain->max_height) terrain->max_height = z;
      set_heightmap_value(terrain,x2,y2,z);
    }
  }
}
